/*
 ķ
   Program..: _DCCALC.PRG                           
   Author...: Roger J. Donnay                       
   Notice...: (c) DONNAY Software Designs 1987-2000 
   Date.....: Dec 10, 2000                          
   Notes....: dCLIP's Pop-Up Calculator             
 Ľ
*/

#include 'inkey.ch'
#include 'dccolor.ch'
#include 'appevent.ch'
#include 'gra.ch'
#include 'xbp.ch'
#include 'dcmsg.ch'
#include 'dcdialog.ch'

#define nENTRY         aPopCalc[1]
#define cFCODE         aPopCalc[2]
#define cMCODE         aPopCalc[3]
#define lDECIMAL       aPopCalc[4]
#define lACCUM         aPopCalc[5]
#define lENTERKEY      aPopCalc[6]
#define nDECCOUNT      aPopCalc[7]
#define aBUTTONS       aPopCalc[8]
#define aSET           aPopCalc[9]
#define aSAVEKEYS      aPopCalc[10]
#define oDLG           aPopCalc[11]
#define nCURVAL        aPopCalc[12]
#define oCALCDISPLAY   aPopCalc[13]
#define oCALCMEMORY    aPopCalc[14]
#define oTOTAL         aPopCalc[15]
#define cKEY           aPopCalc[16]
#define oKEY           aPopCalc[17]
#define cKEYGET        aPopCalc[18]
#define oKEYGET        aPopCalc[19]
#define lCONFIRM       aPopCalc[20]
#define nCALCDISPLAY   aPopCalc[21]
#define oBTN1          aPopCalc[22]
#define oBTN2          aPopCalc[23]
#define nINKEY         aPopCalc[24]
#define cCODE          aPopCalc[25]
#define cSAVESCRN      aPopCalc[26]
#define aDRAG          aPopCalc[27]
#define lPAINTSCRN     aPopCalc[28]
#define lAPPQUIT       aPopCalc[29]
#define cCALCPICTURE   aPopCalc[30]
#define bHELP          aPopCalc[31]

STATIC aCalc := { 0,0,0 }

#define nCALCACCUM     aCalc[1]
#define nCALCMEMORY    aCalc[2]
#define nCALCDECIMALS  aCalc[3]
#pragma Oem2Ansi(ON)

FUNCTION dc_popcalc ( nCurVal, nStRow, nStCol, cTitle, lOk, lModal, bHelp, lInteger )

LOCAL aPopCalc[31], aMouseKeys, nMouseRow, nMouseCol

nCurVal := IIF(Valtype(nCurVal)='N',nCurVal,0)

IF DC_Gui()
  RETURN DC_GuiPopCalc( nCurVal, ;
                        IIF(Valtype(nStRow)='N',nStRow*20,nil), ;
                        IIF(Valtype(nStCol)='N',nStCol*7,nil), ;
                        cTitle, ;
                        @lOk, ;
                        lModal, ;
                        bHelp, ;
                        lInteger )
ENDIF

DEFAULT nStRow := 3, ;
        nStCol := 10, ;
        lInteger := .f.

IF VALTYPE( nStCol ) # 'N' .AND. SetAppFocus():ClassName() = 'XbpCrt'
  nStCol := IIF( COL() > 40, 5, 45 )
ENDIF

DC_ClrArr()
aSET := DC_SaveSet()
aSAVEKEYS := DC_KEYSAVE(.t.)
SETKEY( K_F1, {||_dccalchelp(nStRow,nStCol)} )
SET SCOREBOARD OFF
SET DECIMALS TO 8
SET BELL OFF
nENTRY := 0
lDECIMAL := .F.
cFCODE := '+'
cCODE := ' '
lACCUM := .T.
lENTERKEY := .T.
nINKEY := 13
cMCODE := ' '
lPAINTSCRN := .t.
IF nCurVal > 0
  nCALCACCUM := nCurVal
ENDIF

DO WHILE .T.

  IF lPAINTSCRN
    cSAVESCRN := DC_EXPL( nStRow, nStcol, nStRow+20, nStcol+29 )
    @ nStRow, nStCol+2 SAY '[]'
    @ nStRow+1,nStCol+2 TO nStrow+3,nStCol+27 DOUBLE
    @ nStRow+16,nStCol+9 TO nStRow+18,nStCol+27
    @ nStRow+17,nStCol+2 SAY 'Memory'
    @ nStRow+19,nStCol+20 SAY 'F1:Help'
    @ nStRow+19,nStCol+2 SAY 'F10:Save'
    aMouseKeys := { { nStRow, nStCol+2, nStRow, nStCol+4, K_ESC } ,;
                    { nStRow+19, nStCol+20, nStRow+19, nStCol+26, K_F1 },;
                    { nStRow+19, nStCol+2, nStRow+19, nStCol+9, K_F10 } }
    DC_MOUSEBUTTON( @aMouseKeys, nStRow+4, nStCol+2, nStRow+6, nStCol+5, {'AC'}, 'AC' )
    DC_MOUSEBUTTON( @aMouseKeys, nStRow+4, nStCol+7, nStRow+6, nStCol+10, {' 7'}, '7' )
    DC_MOUSEBUTTON( @aMouseKeys, nStRow+4, nStCol+11, nStRow+6, nStCol+14, {' 8'}, '8' )
    DC_MOUSEBUTTON( @aMouseKeys, nStRow+4, nStCol+15, nStRow+6, nStCol+18, {' 9'}, '9' )
    DC_MOUSEBUTTON( @aMouseKeys, nStRow+4, nStCol+20, nStRow+6, nStCol+23, {' /'}, '/' )
    DC_MOUSEBUTTON( @aMouseKeys, nStRow+4, nStCol+24, nStRow+6, nStCol+27, {' R'}, 'R' )
    DC_MOUSEBUTTON( @aMouseKeys, nStRow+7, nStCol+2, nStRow+9, nStCol+5, {'MR'}, 'MR' )
    DC_MOUSEBUTTON( @aMouseKeys, nStRow+7, nStCol+7, nStRow+9, nStCol+10, {' 4'}, '4' )
    DC_MOUSEBUTTON( @aMouseKeys, nStRow+7, nStCol+11, nStRow+9, nStCol+14, {' 5'}, '5' )
    DC_MOUSEBUTTON( @aMouseKeys, nStRow+7, nStCol+15, nStRow+9, nStCol+18, {' 6'}, '6' )
    DC_MOUSEBUTTON( @aMouseKeys, nStRow+7, nStCol+20, nStRow+9, nStCol+23, {' *'}, '*' )
    DC_MOUSEBUTTON( @aMouseKeys, nStRow+7, nStCol+24, nStRow+9, nStCol+27, {' %'}, '%' )
    DC_MOUSEBUTTON( @aMouseKeys, nStRow+10, nStCol+2, nStRow+12, nStCol+5, {'M-'}, 'M-' )
    DC_MOUSEBUTTON( @aMouseKeys, nStRow+10, nStCol+7, nStRow+12, nStCol+10, {' 1'}, '1' )
    DC_MOUSEBUTTON( @aMouseKeys, nStRow+10, nStCol+11, nStRow+12, nStCol+14, {' 2'}, '2' )
    DC_MOUSEBUTTON( @aMouseKeys, nStRow+10, nStCol+15, nStRow+12, nStCol+18, {' 3'}, '3' )
    DC_MOUSEBUTTON( @aMouseKeys, nStRow+10, nStCol+20, nStRow+12, nStCol+23, {' -'}, '-' )
    DC_MOUSEBUTTON( @aMouseKeys, nStRow+10, nStCol+24, nStRow+12, nStCol+27, {'CE'}, 'CE'+CHR(13) )
    DC_MOUSEBUTTON( @aMouseKeys, nStRow+13, nStCol+2, nStRow+15, nStCol+5, {'M+'}, 'M+' )
    DC_MOUSEBUTTON( @aMouseKeys, nStRow+13, nStCol+7, nStRow+15, nStCol+10, {' 0'}, '0' )
    DC_MOUSEBUTTON( @aMouseKeys, nStRow+13, nStCol+11, nStRow+15, nStCol+14, {' .'}, '.' )
    DC_MOUSEBUTTON( @aMouseKeys, nStRow+13, nStCol+15, nStRow+15, nStCol+18, {' ='}, CHR(13) )
    DC_MOUSEBUTTON( @aMouseKeys, nStRow+13, nStCol+20, nStRow+15, nStCol+23, {' +'}, '+' )
    DC_MOUSEBUTTON( @aMouseKeys, nStRow+13, nStCol+24, nStRow+15, nStCol+27, {'C '}, 'C'+CHR(13) )
    AADD( aMouseKeys, { nStRow, nStCol, nStRow+20, nStCol+30, K_ALT_L } )
    lPAINTSCRN := .f.
  ENDIF
  SET CURSOR OFF
  DC_COLOR( nC_PENDGET )
  @ nStRow+17,nStCol+12 SAY nCALCMEMORY PICT '99999999999.99'
  DC_COLOR( nC_CURRGET )
  IF lACCUM
    @ nStRow+2,nStCol+4 SAY 'T'
    @ nStRow+2,nStCol+10 SAY nCALCACCUM PICT '99999999999.99'
  ELSE
    @ nStRow+2,nStCol+4 SAY cFCODE
    @ nStRow+2,nStCol+10 SAY nENTRY+nCALCDECIMALS PICT '99999999999.99'
  ENDIF
  DC_INKEYRELE(0)
  nINKEY := DC_INKEY(,0,@nMouseRow,@nMouseCol,,,,.t.)
  cCODE := UPPER(CHR(nINKEY))
  IF cCODE = '='
    nINKEY := 13
  ENDIF

  DO CASE

    CASE nINKEY = -101 .AND. ;
         !EMPTY(DC_MOUSEKEY(aMouseKeys,,,nMouseRow,nMouseCol))

    CASE nINKEY = K_ALT_L
      DC_INKEYLAST(-101)
      aDRAG := DC_DRAG( nStRow, nStCol, nStRow+20, nStCol+30, 9 )
      DC_IMPL( cSAVESCRN )
      nStRow := aDRAG[1]
      nStCol := aDRAG[2]
      lPAINTSCRN := .t.

    CASE cCODE>='0' .AND. cCODE<='9'
      IF lENTERKEY .OR. cFCODE=' '
        nCALCACCUM := 0
        nENTRY := 0
        nCALCDECIMALS := 0
        cFCODE := '+'
      ENDIF
      lACCUM := .F.
      IF !lDECIMAL
        nENTRY := nENTRY*10+VAL(cCODE)
      ELSE
        IF nDECCOUNT<1000
          nCALCDECIMALS := nCALCDECIMALS+VAL(cCODE)/nDECCOUNT
          nDECCOUNT *= 10
        ENDIF
      ENDIF

    CASE cCODE='.'
      lACCUM := .F.
      lDECIMAL := .T.
      nDECCOUNT := 10

    CASE (cCODE='+' .OR. cCODE='-' .OR. cCODE='/' .OR. cCODE='*';
      .OR. cCODE='R' .OR. cCODE='%' .OR. nINKEY=13) .AND. cMCODE=' '
      lACCUM := .T.
      IF nINKEY#13 .AND. lENTERKEY
      ELSE
        DO CASE
          CASE cFCODE='+'
            IF cCODE='%'
              nCALCACCUM := nCALCACCUM+nCALCACCUM*.01*(nENTRY+nCALCDECIMALS)
            ELSE
              nCALCACCUM += (nENTRY+nCALCDECIMALS)
            ENDIF
          CASE cFCODE='-'
            IF cCODE='%'
              nCALCACCUM := nCALCACCUM-nCALCACCUM*.01*(nENTRY+nCALCDECIMALS)
            ELSE
              nCALCACCUM -= (nENTRY+nCALCDECIMALS)
            ENDIF
          CASE cFCODE='*'
            nCALCACCUM *= (nENTRY+nCALCDECIMALS)
          CASE cFCODE='/' .AND. (nENTRY+nCALCDECIMALS)#0
            nCALCACCUM /= (nENTRY+nCALCDECIMALS)
          CASE cFCODE='R'
            nCALCACCUM := SQRT(nCALCACCUM)
       ENDCASE
      ENDIF
      lDECIMAL := .F.
      IF cCODE='%'
        cFCODE := ' '
      ENDIF
      IF nINKEY#13
        cFCODE := cCODE
        nENTRY := 0
        nCALCDECIMALS := 0
      ENDIF

    CASE cCODE='A'
      cMCODE := 'A'

    CASE cCODE='M'
      cMCODE := 'M'

    CASE cCODE='C' .AND. cMCODE=' '
      cMCODE := 'C'

    CASE cCODE='C' .AND. cMCODE='A'
      lACCUM := .T.
      nCALCACCUM := 0
      nCALCDECIMALS := 0
      nENTRY := 0
      nCALCMEMORY := 0.00
      cMCODE := ' '
      cFCODE := ' '

    CASE cCODE='C' .AND. cMCODE='M'
      nCALCMEMORY := 0.00
      cMCODE := ' '

    CASE cCODE='E' .AND. cMCODE='C'
      nENTRY := 0
      nCALCDECIMALS := 0
      lDECIMAL := .F.
      cMCODE := ' '
      lACCUM := .F.
      cFCODE := ' '

    CASE cMCODE='C' .AND. nINKEY=13
      nENTRY := 0
      nCALCDECIMALS := 0
      nCALCACCUM := 0
      lDECIMAL := .F.
      cMCODE := ' '
      cFCODE := ' '
      lACCUM := .T.

    CASE cCODE='R' .AND. cMCODE='M'
      nENTRY := nCALCMEMORY
      lACCUM := .F.
      lDECIMAL := .F.
      cMCODE := ' '

    CASE cCODE='-' .AND. cMCODE='M'
      nCALCMEMORY -= nCALCACCUM
      cMCODE := ' '
      nCALCDECIMALS := 0
      nENTRY := 0
      cFCODE := ' '
      lACCUM := .T.

    CASE cCODE='+' .AND. cMCODE='M'
      nCALCMEMORY += nCALCACCUM
      cMCODE := ' '
      nCALCDECIMALS := 0
      nENTRY := 0
      cFCODE := ' '
      lACCUM := .T.

    CASE cCODE='X' .OR. nINKEY=K_F10
      EXIT

    CASE nINKEY = K_ESC
      nCALCACCUM := nCurVal
      EXIT

    OTHERWISE
      DC_TONE(2000,1)

  ENDCASE
  IF nINKEY > 0
    lENTERKEY := .f.
    IF nINKEY=13 .OR. cCODE='='
      lENTERKEY := .T.
    ENDIF
  ENDIF

ENDDO
DC_IMPL( cSAVESCRN )
DC_RestSet( aSET )
DC_KeyRestore( aSAVEKEYS )
nCurVal := nCALCACCUM
DC_INKEYRELE(0)
RETURN nCALCACCUM

* -------------------

STATIC FUNCTION _dccalchelp ( nStRow, nStCol )

LOCAL cSaveScrn := DC_EXPL( nStRow, nStCol, nStRow+20, nStCol+29 )
LOCAL bF1Key := SETKEY(K_F1,nil)
IF DC_LangSet()=DCLANG_POLISH
   @ nStRow+1,nStCol+2 SAY 'AC = Kasuj wszystko'
   @ nStRow+2,nStCol+2 SAY 'MC = Kasuj pami'
   @ nStRow+3,nStCol+2 SAY 'MR = Przywr pami'
   @ nStRow+4,nStCol+2 SAY 'M+ = Dodaj do pamici'
   @ nStRow+5,nStCol+2 SAY 'M- = Odejmij od pamici'
   @ nStRow+6,nStCol+2 SAY 'C  <ENTER> = Usu wszystko'
   @ nStRow+7,nStCol+2 SAY 'CE <ENTER> = Usu wpis'
   @ nStRow+8,nStCol+2 SAY 'Uyj <Enter> dla <=>'
   @ nStRow+9,nStCol+2 SAY ' / = Dzielenie'
   @ nStRow+10,nStCol+2 SAY ' * = Mnoenie'
   @ nStRow+11,nStCol+2 SAY ' - = Odejmowanie'
   @ nStRow+12,nStCol+2 SAY ' + = Dodawanie'
   @ nStRow+13,nStCol+2 SAY ' R = Pierwiastek'
   @ nStRow+14,nStCol+2 SAY ' % = Procent'
   @ nStRow+15,nStCol+2 SAY ' ESC = WYJCIE'
ELSE
   @ nStRow+1,nStCol+2 SAY 'AC = Clear All'
   @ nStRow+2,nStCol+2 say 'MC = Clear Memory'
   @ nStRow+3,nStCol+2 say 'MR = Recall Memory'
   @ nStRow+4,nStCol+2 say 'M+ = Add Total to Memory'
   @ nStRow+5,nStCol+2 say 'M- = Sub Total from Memory'
   @ nStRow+6,nStCol+2 say 'C  <ENTER> = Clear Total'
   @ nStRow+7,nStCol+2 say 'CE <ENTER> = Clear Entry'
   @ nStRow+8,nStCol+2 say 'Use <Enter> for <=>'
   @ nStRow+9,nStCol+2 say ' / = Divide'
   @ nStRow+10,nStCol+2 say ' * = Multiply'
   @ nStRow+11,nStCol+2 say ' - = Subtract'
   @ nStRow+12,nStCol+2 say ' + = Add'
   @ nStRow+13,nStCol+2 say ' R = Square Root'
   @ nStRow+14,nStCol+2 say ' % = Percentage'
   @ nStRow+15,nStCol+2 SAY ' ESC = EXIT'
ENDIF
DC_INKEY(,0)
DC_IMPL(cSaveScrn)
SETKEY( K_F1, bF1Key )
DC_INKEYRELE(0)
RETURN nil

* ----------------

FUNCTION dc_guipopcalc ( nCurVal, nStRow, nStCol, cTitle, lOk, lModal, bHelp, lInteger )

//NOTE: lInteger was added 5/17/2007 by Spyros B. Drakos to enable only integers and disable the decimal point

LOCAL aPopCalc[31], oParent, nCol, nRow, drawingArea, i,;
      nEvent, mp1, mp2, oXbp, oOwner, oAppFocus := SetAppFocus(), ;
      nDecimals, oAppWindow := SetAppWindow(), aGetList

IF Valtype(nCurVal) = 'N'
  nCALCACCUM := nCurVal
ENDIF

DEFAULT lInteger := .f.

bHELP := bHelp
nCURVAL := IIF(Valtype(nCurVal)='N',nCurVal,0)
lModal := IIF(Valtype(lModal)='L',lModal,.t. )

nENTRY := 0
lDECIMAL := .f.
cFCODE := '+'
lACCUM := .t.
lENTERKEY := .t.
cMCODE := ' '
nCALCDISPLAY := nCALCACCUM
nDecimals := Set(_SET_DECIMALS,10)

cCALCPICTURE := _CalcPicture(nCurVal)

aBUTTONS := { ;
  { 40,20,'AC','AC',},;
  { 40,40,'7','7', },;
  { 40,55,'8','8',},;
  { 40,70,'9','9',},;
  { 40,90,'SLASH','/',},;
  { 40,105,'R','R',},;
  { 60,20,'MR','MR',},;
  { 60,40,'4','4',},;
  { 60,55,'5','5',},;
  { 60,70,'6','6',},;
  { 60,90,'AST','*',},;
  { 60,105,'PCT','%',},;
  { 80,20,'M_MINUS','M-',},;
  { 80,40,'1','1',},;
  { 80,55,'2','2',},;
  { 80,70,'3','3',},;
  { 80,90,'MINUS','-',},;
  { 80,105,'CE','CE',},;
  {100,20,'M_PLUS','M+',},;
  {100,40,'0','0',},;
  {100,55,'DOT','.',},;
  {100,70,'EQUAL','=',},;
  {100,90,'PLUS','+',},;
  {100,105,'C','C',} }

oParent := AppDeskTop()
oOwner  := SetAppWindow()

IF Valtype(nStCol) = 'N'
  nCol := nStCol
ELSE
  nCol := (oParent:currentSize()[1]-250)/2
ENDIF

IF Valtype(nStRow) = 'N'
  nRow := oParent:currentSize()[2]-(nStRow)-340
ELSE
  nRow := (oParent:currentSize()[2]-340)/2
ENDIF

oDLG := XbpDialog():new( oParent, oOwner, { nCol, nRow }, { 280, 360 },,.f.)
oDLG:taskList := .T.
IF Valtype(DC_IconDefault())='N'
  oDLG:icon := DC_IconDefault()
ENDIF
oDLG:title := DC_LangMsg(DCMSG_CALC_TITLE)
oDLG:visible := .F.
oDLG:minButton := .f.
oDLG:maxButton := .f.
oDLG:create()
IF lModal
  oDLG:setModalState( XBP_DISP_APPMODAL )
ELSE
  oDLG:setModalState( XBP_DISP_MODELESS )
ENDIF
drawingArea := oDLG:drawingArea
drawingArea:setColorBG( XBPSYSCLR_DIALOGBACKGROUND )
// drawingArea:setFontCompoundName( "10.Courier New Bold" )

oDLG:resize := {|a,b,o,x|x := SetAppFocus(), ;
                         oDLG:drawingArea:hide(), ;
                         DC_AutoReSize(a,b,o,@aGetList), ;
                         oDLG:drawingArea:show(), ;
                         SetAppFocus(x) }

FOR i := 1 TO LEN(aBUTTONS)
  _DCCalc1( aPopCalc, aBUTTONS[i], oDLG, i )
  IF lInteger .AND. aBUTTONS[i,3] == "DOT"    // Added 5/17/2007 by Spyros B. Drakos to disable decimal point
    aBUTTONS[i,5]:disable()                        // Added 5/17/2007 by Spyros B. Drakos to disable decimal point
  ENDIF                                                    // Added 5/17/2007 by Spyros B. Drakos to disable decimal point
NEXT

oCALCDISPLAY := XbpSLE():new( drawingArea, , { 70, 275 }, { 150,30 } )
oCALCDISPLAY:clipSiblings := .T.
oCALCDISPLAY:align := XBPSLE_RIGHT
oCALCDISPLAY:setFontCompoundName( "14.Courier New Bold" )
oCALCDISPLAY:datalink := {|x| IIF( x==nil , Transform(nCALCDISPLAY,cCALCPICTURE), ;
                             nCALCDISPLAY := Val(x) ) }
oCALCDISPLAY:create()
oCALCDISPLAY:setdata()

oTOTAL := XbpStatic():new( drawingArea, , { 40, 275 }, { 30,20 } )
oTOTAL:caption := DC_LangMsg(DCMSG_CALC_TOTAL)
oTOTAL:setFontCompoundName( "14.Courier New Bold" )
oTOTAL:create()

oXbp := XbpStatic():new( drawingArea, , { 40, 235 }, { 30,20 } )
oXbp:caption := DC_LangMsg(DCMSG_CALC_MEM)
oXbp:create()

oCALCMEMORY := XbpSLE():new( drawingArea, , { 70, 235 }, { 150,25 } )
oCALCMEMORY:setFontCompoundName( "12.Courier New Bold" )
oCALCMEMORY:align := XBPSLE_RIGHT
oCALCMEMORY:clipSiblings := .T.
oCALCMEMORY:datalink := ;
   {|x| IIF( x==nil , Transform(nCALCMEMORY,_CalcPicture(nCALCMEMORY)), ;
                      nCALCMEMORY := Val(x) ) }
oCALCMEMORY:create()
oCALCMEMORY:setdata()

oXbp := XbpPushButton():new( drawingArea, , {20,20}, {75,22} )
oXbp:caption := DC_LangMsg(DCMSG_OK)
oXbp:clipSiblings := .T.
oXbp:tabstop := .t.
oXbp:create()
oXbp:activate := {|| _DCCalc2( aPopCalc, 'SAVE', nil, .t. ) }
oXbp:keyboard := {|a,b,o|IIF(a=xbeK_ENTER,Eval(o:activate),nil)}
SetAppFocus(oXbp)

oXbp := XbpPushButton():new( drawingArea, , {100,20}, {75,22} )
oXbp:caption := DC_LangMsg(DCMSG_CANCEL)
oXbp:tabstop := .t.
oXbp:clipSiblings := .T.
oXbp:create()
oXbp:activate := {||lOk := .f., _DCCalc2( aPopCalc, 'ABORT', nil, .t. ) }
oXbp:keyboard := {|a,b,o|lOk := .f., IIF(a=xbeK_ENTER,Eval(o:activate),nil)}

oXbp := XbpPushButton():new( drawingArea, , {180,20}, {75,22} )
oXbp:caption := DC_LangMsg(DCMSG_HELP)
oXbp:tabstop := .t.
oXbp:clipSiblings := .T.
oXbp:create()
oXbp:activate := IIF( Valtype(bHELP)='B',bHelp,{||_DCGuiCalcHelp()} )
oXbp:keyboard := {|a,b,o|IIF(a=xbeK_ENTER,Eval(o:activate),nil)}

DC_ClearEvents()
oDLG:show()
lAPPQUIT := .f.
SetAppWindow(oDLG)

lOk := .t.
nEvent := xbeP_None
DO WHILE nEvent <> xbeP_Close .AND. !lAPPQUIT
  nEvent := AppEvent( @mp1, @mp2, @oXbp )
  IF nEvent = xbeM_Motion .AND. mp1 == NIL
    LOOP
  ENDIF
  oXbp:handleEvent( nEvent, mp1, mp2 )
  IF nEvent = xbeP_Keyboard
    IF mp1 = xbeK_ENTER
      _DCCalc2( aPopCalc, '=', oXbp:cargo, .t. )
    ELSEIF mp1 = xbeK_ALT_H .OR. mp1 == xbeK_F1
      IF Valtype(bHELP) = 'B'
        Eval(bHELP)
      ELSE
        _DCGuiCalcHelp()
      ENDIF
    ELSEIF mp1 = xbeK_ALT_C
      EXIT
    ELSEIF mp1 = xbeK_ALT_O
      nCURVAL := nCALCACCUM
      EXIT
    ELSEIF mp1 = xbeK_ESC .OR. mp1 = K_ESC
      lOk := .f.
      EXIT
    ELSE
      _DCCalc2( aPopCalc, Chr(mp1), oXbp:cargo, .t. )
    ENDIF
    DC_ClearEvents()
  ENDIF
ENDDO

oDLG:setModalState( XBP_DISP_MODELESS )
oDLG:Destroy()
SetAppFocus(oAppFocus)
Set(_SET_DECIMALS,nDecimals)
SetAppWindow(oAppWindow)

nCurVal := nCURVAL

RETURN nCurVal

* -----------------

STATIC PROC _dccalc1 ( aPopCalc, aButton, oDlg, nElement )

aButton[5] := ;
  XbpPushButton():new( oDlg:drawingArea, , ;
      {(aButton[2]*2),260-(aButton[1]*2)}, {30,30} )
aButton[5]:caption := aButton[4]
aButton[5]:tabstop := .t.
aButton[5]:setFontCompoundName( "14.Courier New Bold" )
aButton[5]:create()
aButton[5]:activate := {|| _DCCalc2( aPopCalc, aButton[4],nElement,.t.) }
aButton[5]:keyboard := {|a,b,o|IIF(a=xbeK_ENTER,Eval(o:activate),nil)}
aButton[5]:cargo := nElement

RETURN

* -----------------

STATIC PROC _dccalc2 ( aPopCalc, cKey, nElement, lGui )

cKEY := cKey
* oKEYGET:cText := ' '

DO CASE

    CASE cKey=='SAVE'
      IF !lGui
        DC_RestSet( aSET )
        DC_KeyRestore( aSAVEKEYS )
      ENDIF
      IF !lACCUM
        cMCODE := ' '
        _DCCalc2( aPopCalc, '=', 0, .t. )
      ENDIF
      nCURVAL := nCALCACCUM
      lAPPQUIT := .t.

    CASE cKey=='ABORT'
      lAPPQUIT := .t.

    CASE cKey>='0' .AND. cKey<='9'
      IF lENTERKEY .OR. cFCODE=' '
        nCALCACCUM := 0
        nENTRY := 0
        nCALCDECIMALS := 0
        cFCODE := '+'
      ENDIF
      lACCUM := .f.
      IF !lDECIMAL
        nENTRY := nENTRY*10+VAL(cKey)
      ELSE
        IF nDECCOUNT<1000000000
          nCALCDECIMALS := nCALCDECIMALS+VAL(cKey)/nDECCOUNT
          nDECCOUNT *= 10
        ENDIF
      ENDIF

    CASE cKey=='.' .OR. cKey==','
      lACCUM := .f.
      lDECIMAL := .t.
      nDECCOUNT := 10

    CASE (cKey=='+' .OR. cKey=='-' .OR. cKey=='/' .OR. cKey=='*';
      .OR. cKey=='R' .OR. cKey=='%' .OR. cKey=='=') .AND. cMCODE=' '
      lACCUM := .t.
      IF cKey#'=' .AND. lENTERKEY
      ELSE
        DO CASE
          CASE cFCODE='+'
            IF cKey='%'
              nCALCACCUM := nCALCACCUM+nCALCACCUM*.01*(nENTRY+nCALCDECIMALS)
            ELSE
              nCALCACCUM += (nENTRY+nCALCDECIMALS)
            ENDIF
          CASE cFCODE='-'
            IF cKey='%'
              nCALCACCUM := nCALCACCUM-nCALCACCUM*.01*(nENTRY+nCALCDECIMALS)
            ELSE
              nCALCACCUM -= (nENTRY+nCALCDECIMALS)
            ENDIF
          CASE cFCODE='*'
            IF cKey='%'
              nCALCACCUM := .01*nENTRY*(nCALCDECIMALS+nCALCACCUM)
            ELSE
              nCALCACCUM := (nENTRY+nCALCDECIMALS)*nCALCACCUM
            ENDIF
          CASE cFCODE='/' .AND. (nENTRY+nCALCDECIMALS)#0
            nCALCACCUM /= (nENTRY+nCALCDECIMALS)
          CASE cFCODE='R'
            nCALCACCUM := SQRT(nCALCACCUM)
       ENDCASE
      ENDIF
      lDECIMAL := .F.
      IF cKey='%'
        cFCODE := ' '
      ENDIF
      IF cKey#'='
        cFCODE := cKey
        nENTRY := 0
        nCALCDECIMALS := 0
      ENDIF

    CASE cKey=='A'
      cMCODE := 'A'

    CASE cKey=='M'
      cMCODE := 'M'

    CASE cKey=='C' .AND. cMCODE=' '
      cMCODE := 'C'

    CASE (cKey=='C' .AND. cMCODE='A') .OR. cKey=='AC'
      lACCUM := .t.
      nCALCACCUM := 0
      nCALCDECIMALS := 0
      nENTRY := 0
      nCALCMEMORY := 0.00
      cMCODE := ' '
      cFCODE := ' '

    CASE (cKey=='C' .AND. cMCODE='M') .OR. cKey=='MC'
      nCALCMEMORY := 0.00
      cMCODE := ' '

    CASE (cKey=='E' .AND. cMCODE='C') .OR. cKey=='CE'
      nENTRY := 0
      nCALCDECIMALS := 0
      lDECIMAL := .f.
      cMCODE := ' '
      lACCUM := .f.
      cFCODE := ' '

    CASE (cMCODE=='C' .AND. cKey='=') .OR. cKey=='C'
      nENTRY := 0
      nCALCDECIMALS := 0
      nCALCACCUM := 0
      lDECIMAL := .f.
      cMCODE := ' '
      cFCODE := ' '
      lACCUM := .t.

    CASE (cKey=='R' .AND. cMCODE='M') .OR. cKey='MR'
      nENTRY := nCALCMEMORY
      lACCUM := .f.
      lDECIMAL := .f.
      cMCODE := ' '

    CASE (cKey=='-' .AND. cMCODE='M') .OR. cKey='M-'
      nCALCMEMORY -= nCALCACCUM
      cMCODE := ' '
      nCALCDECIMALS := 0
      nENTRY := 0
      cFCODE := ' '
      lACCUM := .T.

    CASE (cKey=='+' .AND. cMCODE='M') .OR. cKey='M+'
      nCALCMEMORY += nCALCACCUM
      cMCODE := ' '
      nCALCDECIMALS := 0
      nENTRY := 0
      cFCODE := ' '
      lACCUM := .T.

  ENDCASE

  IF !Empty(cKey)
    lENTERKEY := .f.
    IF cKey='='
      lENTERKEY := .T.
    ENDIF
  ENDIF
  IF lACCUM
    oTOTAL:SetCaption('T')
    nCALCDISPLAY := nCALCACCUM
  ELSE
    oTOTAL:SetCaption(cFCODE)
    nCALCDISPLAY := nENTRY+nCALCDECIMALS
  ENDIF

IF lDECIMAL .AND. nCALCDECIMALS = 0
   nCALCDISPLAY += .0
ENDIF

cCALCPICTURE := _CalcPicture( nCALCDISPLAY )
oCALCDISPLAY:SetData()
oCALCMEMORY:SetData()

RETURN

* ----------------------

STATIC FUNCTION _CalcPicture( nVal )

LOCAL cPicture, cVal, i

cVal := Alltrim(Str(nVal))

FOR i := Len(cVal) TO 1 STEP -1
  IF !(SubStr(cVal,i,1) == '0')
    EXIT
  ENDIF
NEXT

cVal := SubStr(cVal,1,i)

cPicture := Repl('9',Len(cVal))
cPicture := Stuff(cPicture,At('.',cVal),1,'.')

IF Substr(cPicture,1,1) == '.'
  cPicture := ''
ELSEIF Right(cPicture,1) == '.'
  cPicture += '9'
ENDIF

RETURN cPicture


/* ------------------- */

STATIC PROCEDURE _dcguicalchelp ()

LOCAL lGui := DC_Gui(.t.), aMessage, cTitle

IF DC_LangSet() = DCLANG_GERMAN
  aMessage := { ;
    'AC = Lsche Alles',;
    'MC = Lsche Speicher',;
    'MR = Hole Speicherinhalt zurck',;
    'M+ = Addiere Ergebnis zum Speicher',;
    'M- = Subtrahiere Ergebnis vom Speicher',;
    'C  = Lsche Ergebnis',;
    'CE = Lsche Eingabe',;
    '= od.<Enter> fr Ergebnis',;
    ' / = Dividieren',;
    ' * = Multiplizieren',;
    ' - = Subtrahieren',;
    ' + = Addieren',;
    ' R = Quadratwurzel',;
    ' % = Prozent',;
    ' ESC = Ende' }

  cTitle := 'Rechner Hilfe'

ELSEIF DC_LangSet() = DCLANG_SLOVENIAN

  aMessage := { ;
    'AC = Zbrii vse',;
    'MC = Zbrii spomin',;
    'MR = Priklii iz spomina',;
    'M+ = Pritej k spominu',;
    'M- = Odtej od spomina',;
    'C  = Zbrii rezultat',;
    'CE = Zbrii vnos',;
    'Uporbi <Enter> za <=>',;
    ' / = Delji',;
    ' * = Mnoi',;
    ' - = Odtej',;
    ' + = Pritej',;
    ' R = Kvadratni koren',;
    ' % = Stotinke',;
    ' ESC = IZHOD' }

  cTitle := 'Pomoc do kalkulatora'

ELSEIF DC_LangSet() = DCLANG_POLISH

  aMessage := { ;
   'AC = Kasuj wszystko',;
   'MC = Kasuj pami',;
   'MR = Przywr pami',;
   'M+ = Dodaj do pamici',;
   'M- = Odejmij od pamici',;
   'C  <ENTER> = Usu wszystko',;
   'CE <ENTER> = Usu wpis',;
   'Uyj <Enter> dla <=>',;
   ' / = Dzielenie',;
   ' * = Mnoenie',;
   ' - = Odejmowanie',;
   ' + = Dodawanie',;
   ' R = Pierwiastek',;
   ' % = Procent',;
   ' ESC = WYJCIE'}

  cTitle := 'Pomoc do kalkulatora'


ELSEIF DC_LangSet() = DCLANG_SLOVAK

  aMessage := { ;
   'AC = Vyma vetko',;
   'MC = Vyma pam',;
   'MR = Vyvolaj z pamte',;
   'M+ = Pridaj do pamte',;
   'M- = Odrtaj z pamte',;
   'C  <ENTER> = Vyma vsledok',;
   'CE <ENTER> = Vyma vstup',;
   'Poui <Enter> pre <=>',;
   ' / = Delenie',;
   ' * = Nsobenie',;
   ' - = Odtanie',;
   ' + = Stanie',;
   ' R = Mocnina',;
   ' % = Percento',;
   ' ESC = EXIT'}

  cTitle := 'Npoveda pre kalkulaku'

ELSEIF DC_LangSet() = DCLANG_CZECH

  aMessage := { ;
   'AC = Vyma vechno',;
   'MC = Vyma pam',;
   'MR = Vyvolej z pamti',;
   'M+ = Pidej do pamti',;
   'M- = Odeti z pamti',;
   'C  <ENTER> = Vyma vsledek',;
   'CE <ENTER> = Vyma vstup',;
   'Pouij <Enter> pro <=>',;
   ' / = Dlen',;
   ' * = Nsoben',;
   ' - = Odtn',;
   ' + = Stn',;
   ' R = Mocnn',;
   ' % = Procento',;
   ' ESC = EXIT'}

  cTitle := 'Npovda pro kalkultor'

ELSE

  aMessage := { ;
    'AC = Clear All',;
    'MC = Clear Memory',;
    'MR = Recall Memory',;
    'M+ = Add Total to Memory',;
    'M- = Sub Total from Memory',;
    'C  = Clear Total',;
    'CE = Clear Entry',;
    'Use <Enter> for <=>',;
    ' / = Divide',;
    ' * = Multiply',;
    ' - = Subtract',;
    ' + = Add',;
    ' R = Square Root',;
    ' % = Percentage',;
    ' ESC = EXIT' }

  cTitle := 'Calculator Help'

ENDIF

DC_MsgBox(,,aMessage,cTitle)
DC_Gui(lGui)

RETURN



